﻿---------------------------------------------------------------------------------
--
-- Prat - A framework for World of Warcraft chat mods
--
-- Copyright (C) 2006-2007  Prat Development Team
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to:
--
-- Free Software Foundation, Inc., 
-- 51 Franklin Street, Fifth Floor, 
-- Boston, MA  02110-1301, USA.
--
--
-------------------------------------------------------------------------------



-- Gotta have Prat
if not Prat then return end

if not AceLibrary:HasInstance("FuBarPlugin-2.0") then return end

local L = AceLibrary("AceLocale-2.2"):new("PratFu")

L:RegisterTranslations("enUS", function() return {
    ["Prat"] = true,
    ["Options Menu"] = true,
    ["FuBar"] = true,
    ["minimap"] = true,
    ["Minimap"] = true,
    ["Toggle the minimap button."] = true,
    ["Show it again with /prat minimap."] = true,
    ["%s icon is now %s."] = true,
    ["hidden"] = true,
    ["shown"] = true,
    ["The standard FuBar options."] = true,
    ["FuBar Options"] = true,

-- Note These Will Go Away By Release
-- So You dont need to localize them
	["Color Key"] = true,
	["Module Uses Prat Events"] = true,
	["Module Is Defective"] = true,
	["Module Needs Categorization"] = true,
    ["Module Hidden From the User"] = true,
    ["Module Status Normal"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
    ["Prat"] = "Prat",
    ["Options Menu"] = "메뉴 설정",
    ["FuBar"] = "Fubar",
--    ["minimap"] = true,
    ["Minimap"] = "미니맵",
    ["Toggle the minimap button."] = "미니맵 버튼 켜고/끄기",
    ["Show it again with /prat minimap."] = "/prat minimap 명령으로 미니맵 아이콘을 다시 표시할 수 있습니다.",
    ["%s icon is now %s."] = "%s 아이콘 : %s",
    ["hidden"] = "숨김",
    ["shown"] = "표시",
    ["The standard FuBar options."] = "기본 FuBar 설정입니다.",
    ["FuBar Options"] = "FuBar 설정",
    ["Color Key"] = "색상 분류",
    ["Module Uses Prat Events"] = "Prat 이벤트 사용 모듈",
    ["Module Is Defective"] = "불완전한 모듈",
    ["Module Needs Categorization"] = "분류 되어야 할 모듈",
    ["Module Hidden From the User"] = "숨겨진 모듈",
    ["Module Status Normal"] = "정상 상태 모듈",
} end)

L:RegisterTranslations("deDE", function() return {
    ["Prat"] = "Prat",
    ["Options Menu"] = "Options Men\195\188",
    ["FuBar"] = "FuBar",
    ["minimap"] = "minimap",
    ["Minimap"] = "Minimap",
    ["Toggle the minimap button."] = "Aktiviere die Minimap Taste.",
    ["Show it again with /prat minimap."] = "Zeige es wieder mit /prat minimap.",
    ["%s icon is now %s."] = "%s Symbol ist nun %s.",
    ["hidden"] = "versteckt",
    ["shown"] = "sichtbar",
    ["The standard FuBar options."] = "Die Standart FuBar Optionen.",
    ["FuBar Options"] = "FuBar Optionen",
	["Color Key"] = "Farben Schl\195\188ssel",
	["Module Uses Prat Events"] = "Modul benutzt Prat Events",
	["Module Is Defective"] = "Modul ist Defekt",
	["Module Needs Categorization"] = "Modul ist nicht 2.0 Kompatibel",
    ["Module Hidden From the User"] = "Modul ist versteckt von dem Benutzer",
    ["Module Status Normal"] = "Modul Status Normal",
} end)

L:RegisterTranslations("frFR", function() return {
    ["Prat"] = "Prat",
    ["Options Menu"] = "Menu d'options",
    ["FuBar"] = "FuBar",
    ["minimap"] = "mini-carte",
    ["Minimap"] = "Mini-carte",
    ["Toggle the minimap button."] = "Activer/d\195\169sactiver le bouton sur la mini-carte.",
    ["Show it again with /prat minimap."] = "Affichez le de nouveau avec /prat minimap.",
    ["%s icon is now %s."] = "L'ic\195\180ne %s est maintenant %s.",
    ["hidden"] = "cach\195\169e",
    ["shown"] = "affich\195\169e",
    ["The standard FuBar options."] = "Les options standard de FuBar.",
    ["FuBar Options"] = "Options de FuBar",
	["Color Key"] = "Codes couleurs",
	["Module Uses Prat Events"] = "Module utilisant les évènements de Prat",
	["Module Is Defective"] = "Module défectueux",
	["Module Needs Categorization"] = "Module non compatible avec Prat 2.0",
    ["Module Hidden From the User"] = "Module caché à l'utilisateur",
    ["Module Status Normal"] = "Module standard",
} end)

L:RegisterTranslations("esES", function() return {
    ["Prat"] = "Prat",
    ["Options Menu"] = "Men\195\186 de Opciones",
    ["FuBar"] = "FuBar",
    ["minimap"] = "minimapa",
    ["Minimap"] = "Minimapa",
    ["Toggle the minimap button."] = "Determina si se activa el bot\195\179n del minimapa",
    ["Show it again with /prat minimap."] = "Mu\195\169stralo de nuevo con /prat minimap",
    ["%s icon is now %s."] = "El icono de %s es ahora %s.",
    ["hidden"] = "oculto",
    ["shown"] = "mostrado",
    ["The standard FuBar options."] = "Las opciones est\195\161ndar de FuBar",
    ["FuBar Options"] = "Opciones de FuBar",

-- Note These Will Go Away By Release
-- So You dont need to localize them
	["Color Key"] = "Clave de Colores",
	["Module Uses Prat Events"] = "El m\195\179dulo usa eventos de Prat",
	["Module Is Defective"] = "El m\195\179dulo es Defectuoso",
	["Module Needs Categorization"] = "El m\195\179dulo necesita categorizaci\195\179n",
    ["Module Hidden From the User"] = "M\195\179dulo oculto al usuario",
    ["Module Status Normal"] = "M\195\179dulo normal",
} end)


-- Code from bigwigs can be used to provide a console command)
local mm = Prat:NewModule(Prat:RequestModuleName("minimap"))
mm.moduleHidden = true
mm.hasFuBar = IsAddOnLoaded("FuBar") and FuBar
function mm:GetModuleOptions()
    self.moduleOptions = not mm.hasFuBar and {
    	type = "toggle",
    	name = L["Minimap"],
    	desc = L["Toggle the minimap button."],
    	get = function() return PratFu.minimapFrame and PratFu.minimapFrame:IsVisible() or false end,
    	set = function(v)
    		if v then
    			PratFu:Show()
    		else
    			PratFu:Hide()
    			Prat:Print(L["Show it again with /prat minimap."])
    		end
    	end,
    	map = {[false] = L["hidden"], [true] = L["shown"]},
    	message = L["%s icon is now %s."],
    	hidden = function() return mm.hasFuBar end,
    }

    return self.moduleOptions
end

PratFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDebug-2.0", "AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")
PratFu:RegisterDB("PratFuDB")
PratFu:RegisterDefaults("profile", {
    autoupdate = true,
	varTree = {},
	browseHistory = {}, -- saves all inputs in debug text frame
	browsePos = 1,	-- the present position while browsing the history
	closeOnEnter = nil, -- if set , edit box closes on normal enter
	editBoxWidth = 200,
	editBoxAlpha = 0.8,
	showMiniMap = false,
	displayIndex = nil,
	showVarName = true,
	showFullVarName = true,
	showValue = 1,
	showType = 1,
	autoDetach =1,
	autoAttach = 1,
	lineThreshhold = 59,
	showDepth = nil, -- set to 1 if the depth of the table nodes is shown behind em
	newTreeBuild = 0,
	varDisplaySize =4,  --internal value to figure out how many lines the var display takes in tooltip
	wipeLastTooltip =1, 
	displayedVariable = nil, -- the last querried variable for build tree (might be invalid)
	rootVariable = "Prat.debugdata", -- the root variable of the search
	newRootVariable = nil, -- new variable to use will be rootVariable if it is confirmed working
	editMode = nil, -- if set to 1 indicates that editing is taking place
	editIndex = nil, -- set to the index that is edited, if editmode is on
	lastEditBoxText = nil, -- if this is set, the last editboxtext that was erased by editing is stored here
	editBoxVisible = nil, -- indicates if the editbox was visible b4 editing or not
	showValueInTree = 1, -- 1 means the var value will be shown in tooltiptree
	showTypeInTree = nil, -- 1 means the var type will be shown in tooltiptree
})
PratFu.title = "Prat"
PratFu.name = "FuBar - Prat"

PratFu.hasIcon = "Interface\\Addons\\Prat\\textures\\prat"
PratFu.cannotDetachTooltip = false
PratFu.hideWithoutStandby = true
PratFu.clickableTooltip = true

PratFu.OnMenuRequest = Prat.Options

local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(PratFu)
	for k,v in pairs(args) do
	if PratFu.OnMenuRequest.args[k] == nil then
		PratFu.OnMenuRequest.args[k] = v
	end
end

function PratFu:OnEnable()
	self:RegisterEvent("Prat_DebugModeChanged", "Update")
	self:RegisterEvent("PratFu_Update", "Update")
	self:RegisterEvent("Prat_PostAddMessage", "UpdateTree")
    self:SetDebugging(Prat:IsDebugging())
end

function PratFu:UpdateTree()
	if Prat:IsDebugging() and Prat.db.profile.integratedDebugger and Prat.db.profile.autoupdate  then
		PratFu:BuildTree(PratFu.db.profile.rootVariable)

        PratFu.chatFrame = this:GetID()
	end
end

function PratFu:OnTextUpdate()
	local str = self:GetTitle()..CLR:Colorize(Prat.Colors.VERSION2,"2.0")
	
	if Prat:IsDebugging() then 
		str = str.." - "
	
		if Prat:IsDebugging() then 
			str = str..CLR:Colorize("ff8080", "Debug  ")
		end
		
		str = str..CLR:Colorize(Prat.Colors.VERSION2, Prat.db.profile.doReplace and "Replacing" or "")
	end

	self:SetText(str)
end
function PratFu:OnClick()
	if Prat:IsDebugging() then
		if IsShiftKeyDown() then 
			ReloadUI()
		elseif IsControlKeyDown() then
			self.db.profile.varTree = {};
            self.db.profile.autoupdate = not self.db.profile.autoupdate
    		self:ReattachTooltip();
	    	self:Update();
		else
			PratFu:BuildTree(PratFu.db.profile.rootVariable)
		end
	end
end

function PratFu:OnDebugEnable()
    if not Prat:IsDebugging() then 
        Prat:SetDebugging(true)
    end
end 

function PratFu:OnDebugDisable()
    Prat:SetDebugging(false)
end 

local tablet =  AceLibrary("Tablet-2.0")



--[[

Prat.Colors = {
    BROKEN = "ff8080",
    CONFIRMEDTAINT = "ff2020",
    TAINT =  "ffff20",
    BADINIT = "ffff80",
    BADENABLE = "ffff80",
    PRATEVENTS = "8080ff",
    VERSION2 = "8080ff",
    HIDDEN = "808080",
    CATEGORY = "8080ff",
    UPDATED = "60ff60"                 -- This will show which modules were updated since you last ran    
}
--]]


function PratFu:OnTooltipUpdate()
    local pc = Prat.Colors

	if tablet then
		tablet:SetTitle(Prat.VERSION_STRING)
--[[
        if not (Prat:IsDebugging() and Prat.db.profile.integratedDebugger) then
    	    local cat = tablet:AddCategory(
    	        'text', L["Color Key"],
    	        'textR', 1,
    			'textG', 1,
    			'textB', 0,
    	        'columns', 1,
    			'child_indentation', 10
    	    )	
    	
    		cat:AddLine('text', CLR:Colorize(pc.PRATEVENTS, L["Module Uses Prat Events"]))
    		cat:AddLine('text', CLR:Colorize(pc.BROKEN, L["Module Is Defective"]))
    		cat:AddLine('text', CLR:Colorize(pc.NEEDSCATEGORIES, L["Module Needs Categorization"]))	
    		cat:AddLine('text', CLR:Colorize("808080", L["Module Hidden From the User"]))	
    		cat:AddLine('text', CLR:Colorize("ffffff", L["Module Status Normal"]))	
		end
--]]		
		if Prat:IsDebugging() then
		    local hint = ""
		    if  Prat.db.profile.integratedDebugger then
			    self:OnDebugTooltipUpdate()
			    hint = hint.."|cffeda55fClick|r to refresh the debug data\n"..
                    	     "|cffeda55fCtrl-Click|r to toggle debugger auto updating\n"
		    end
	    	tablet:SetHint(hint.."|cffeda55fShift-Click|r to ReloadUI")
	    end
	end
end









function PratFu:EndEditing()	

end

function PratFu:StartEditing(index)	

end


function PratFu:OnItemClick(index)	
		
	self:EndEditing();
	
	if (index <= 0) or (not self.db.profile.varTree[index]) then
		return;
	end
	
	local selectNewTree = 1;	
	local presentVar;
	
	if (IsShiftKeyDown()) then
		if (self.db.profile.varTree[index].expanded) then -- is a table
			node = self.db.profile.varTree[index];
			presentVar = self.db.profile.displayedVariable;			
			if (node.parentIndex ~= 0) then			
				subnode =	self.db.profile.varTree[node.parentIndex];
				if (subnode.parentIndex == 0) then -- this is a node 1 above parent										
					presentVar = presentVar.."."..node.name;
					--DEFAULT_CHAT_FRAME:AddMessage("1st Child clicked "..node.name.." "..presentVar);
				else
					subnode_two =	self.db.profile.varTree[subnode.parentIndex];
					if (subnode_two.parentIndex == 0) then -- this is a node 2 above parent
						presentVar = presentVar.."."..subnode.name.."."..node.name;
						--DEFAULT_CHAT_FRAME:AddMessage("2nd Child clicked "..node.name.." "..subnode.name.." "..presentVar);
					else
						subnode_three =	self.db.profile.varTree[subnode_two.parentIndex];
						if (subnode_three.parentIndex == 0) then -- this is a node 3 above parent
							presentVar = presentVar.."."..subnode_two.name.."."..subnode.name.."."..node.name;
							--DEFAULT_CHAT_FRAME:AddMessage("3rd Child clicked "..node.name.." "..subnode.name.." "..subnode_two.name.." "..presentVar);
						else
							selectNewTree = nil;
							DebuggerFu:TextMessage("Limited to 3 steps deeper jumping - use 2 steps to get there !",1);
						end
					end					
				end
			end
		else --shift click on normal node
			--DEFAULT_CHAT_FRAME:AddMessage("Start Editing");
			selectNewTree = nil;
			self:StartEditing(index);
		end
	elseif (IsControlKeyDown()) then -- collapse/expand all nodes
		selectNewTree = nil;
		if (self.db.profile.varTree[index].expanded) then -- is a table
			local depth = self.db.profile.varTree[index].depth;
			if self.db.profile.varTree[index].expanded == 1 then
				self:ToggleAllNodes(depth,0);
			else
				self:ToggleAllNodes(depth,1);
			end				
		end		
	else	
		selectNewTree = nil;
		if (self.db.profile.varTree[index].expanded) then -- is a table
			if self.db.profile.varTree[index].expanded == 1 then
				self.db.profile.varTree[index].expanded =0;
			else
				self.db.profile.varTree[index].expanded =1;
			end	
		end
	end
	
	if (presentVar) and (selectNewTree) then		
		self:BuildTree(presentVar);	
	else
		self.db.profile.displayIndex = index;
		self:UpdateText();		
	end
end


function PratFu:TreeUp()	
	local found = true;
	local firstStep = true;
	local name = "";

	local variableName = self.db.profile.displayedVariable;
	local variable;
	
	found,_,part_one,part_two = string.find(variableName,"(.+)%.(.+)")		
	if (found) then
		self:BuildTree(tostring(part_one));			
	end	
	
	--DEFAULT_CHAT_FRAME:AddMessage("Tree up command "..self.db.profile.displayedVariable);	
end
function PratFu:UseBarDisplay()	-- determins whether the bar is used for display or the tooltip
	return nil;
end
function PratFu:GetFullVarName(index)
	--DEFAULT_CHAT_FRAME:AddMessage("Showing full var name "..self.db.profile.displayedVariable);
	local idx = index;
	local txt = self.db.profile.varTree[idx].name;
	while self.db.profile.varTree[idx].parentIndex > 0 do
		idx = self.db.profile.varTree[idx].parentIndex;
		if (self.db.profile.varTree[idx].parentIndex > 0) then
			txt = self.db.profile.varTree[idx].name.."."..txt;
		end
	end
	txt = self.db.profile.displayedVariable.."."..txt;
	return txt;
end
function PratFu:OnDebugTooltipUpdate()
    PratFu.chatFrameSel = SELECTED_CHAT_FRAME:GetID()

	local cat = tablet:AddCategory(
		'columns', 2,
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 1
	)
	
	if (not self.db.profile.varTree[1]) then
		return;
	end
	
	if (self.db.profile.varDisplaySize) and (not self:UseBarDisplay()) then
		if (self.db.profile.displayIndex) and (self.db.profile.varTree[self.db.profile.displayIndex]) then					
			local pv = self.db.profile.varTree[self.db.profile.displayIndex];
								
			if (self.db.profile.showVarName) then
				if (self.db.profile.showFullVarName) then
					cat:AddLine(
						'text', self:GetFullVarName(self.db.profile.displayIndex),
						'textR', 1,
						'textG', 0.496,
						'textB', 0				
					)						
				else				
					cat:AddLine(
						'text', pv.name,
						'textR', 1,
						'textG', 0.496,
						'textB', 0				
					)	
				end				
			end
		
			if type(pv.value) ~= "nil" then
				--DEFAULT_CHAT_FRAME:AddMessage("Adding : "..type(pv.value))			
				if (self.db.profile.showType) then								
					cat:AddLine(
						'text', type(pv.value),
						'textR', 0,
						'textG', 1,
						'textB', 0				
					)		
				end
				
				if (self.db.profile.showValue) then				
					if (type(pv.value) == "string") then
						cat:AddLine(
							'text', "\'"..pv.value.."\'"
						)
						cat:AddLine(
							'text', "\'"..(pv.value):gsub("|", "||").."\'"
						)							
											
					else					
						cat:AddLine(
							'text', pv.value
						)					
					end
				end				
			else
				if (self.db.profile.showType) then								
					cat:AddLine(
						'text', "table",
						'textR', 0,
						'textG', 1,
						'textB', 0				
					)		
				end

				if (self.db.profile.showValue) then		
					if (self.db.profile.showDepth) then
						cat:AddLine(
							'text', "["..pv.depth.."]"
						)					
					else
						cat:AddLine(
							'text', "-"
						)					
					end					
				end
			end			
		else
		end		
		cat:AddLine(
				'text', " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
		)						
	end
	
	
	local line = {};	
			
	line['text'] = self.db.profile.varTree[1].name
	line['func'] = 'TreeUp'
	line['arg1'] = self			
	--line['arg2'] = i
	line['hasCheck'] = false							
	
	cat:AddLine(line);
	
	local collapseNodeIndex = 0; 
	
	for i,_ in ipairs(self.db.profile.varTree) do
		if (i > 1) then			
			local line = {};	
			
			if (collapseNodeIndex > 0) and (self.db.profile.varTree[i]) and (self.db.profile.varTree[i].parentIndex > collapseNodeIndex) then
			else
				collapseNodeIndex = 0;
			
			--	DEFAULT_CHAT_FRAME:AddMessage("Adding : "..i.." "..self.db.profile.varTree[i].name)
				local spacing = "";
				for i=1,self.db.profile.varTree[i].depth-1 do
					spacing = spacing.."   ";
				end
				line['text'] = spacing..self.db.profile.varTree[i].name;
				--line['justify'] = "LEFT"
				line['func'] = 'OnItemClick'
				line['arg1'] = self			
				line['arg2'] = i
				line['hasCheck'] = true							
									
				if (self.db.profile.varTree[i].expanded) then -- is a table
					if (self.db.profile.showDepth) then
						line['text'] = line['text'].." ["..self.db.profile.varTree[i].depth.."]";
					end
					line['checked'] = true				
					if (self.db.profile.varTree[i].expanded == 1) then
						line['checkIcon'] = "Interface\\Buttons\\UI-MinusButton-Up";
					else
						collapseNodeIndex = self.db.profile.varTree[i].parentIndex;
--						DEFAULT_CHAT_FRAME:AddMessage("Collapsing all > : "..collapseNodeIndex.." "..self.db.profile.varTree[i].name)
						line['checkIcon'] = "Interface\\Buttons\\UI-PlusButton-Up";
					end					
				else -- show the value				
					if (self.db.profile.showValueInTree) then				
						if (type(self.db.profile.varTree[i].value) == "string") then
							line['text'] = line['text'].." = '"..self.db.profile.varTree[i].value.."'";
						elseif (type(self.db.profile.varTree[i].value) == "boolean") then
							if (self.db.profile.varTree[i].value == true) then
								line['text'] = line['text'].." = true";
							else
								line['text'] = line['text'].." = false";
							end
						else
							line['text'] = line['text'].." = "..self.db.profile.varTree[i].value;
						end
					end
				
					if (self.db.profile.showTypeInTree) then
						line['text'] = line['text'].." {"..type(self.db.profile.varTree[i].value).."}";
					end
												
					line['checked'] = false				
					line['textR'] = 1;
					line['textG'] = 1;
					line['textB'] = 0;				
				end
			
				cat:AddLine(line)					
			end
		end
	end	
	
	if (self.db.profile.newTreeBuild == 1) then
		self:ScheduleEvent("PratFu_Update",self.CheckTooltipAttachment, 0.5, self);		
		self.db.profile.newTreeBuild = 0;		
	end	
end
function PratFu:CheckTooltipAttachment(onlyAttach)

end
function PratFu:TextMessage(msg,error)
	if (error) then
--		DEFAULT_CHAT_FRAME:AddMessage("PratFu (Error) : "..msg);
	else
--		DEFAULT_CHAT_FRAME:AddMessage("DebuggerFu : "..msg);
	end
end


-- Build the variable's tree
function PratFu:BuildTree(variableName)	
	self.db.profile.displayIndex = nil;
	self.db.profile.displayedVariable = variableName; 

	-- Empty the tree
	self.db.profile.varTree = {};
	
	--DEFAULT_CHAT_FRAME:AddMessage("name "..variableName);
		
	local part_one,part_two
	local found = true;
	
	local varName = variableName;
	local varParts = {};				
	local aVar;
				
	while (found) do				
		found,_,part_one,part_two = string.find(varName,"(.+)%.(.+)")		
		if (found) then
			table.insert(varParts,1,part_two);
			--DEFAULT_CHAT_FRAME:AddMessage("adding "..part_two);
			varName = part_one;
		else
			table.insert(varParts,1,varName);
			--DEFAULT_CHAT_FRAME:AddMessage("adding "..varName);
		end
	end
	
	--DEFAULT_CHAT_FRAME:AddMessage("varparts "..#varParts.." - "..varParts[#varParts]);
	
	aVar = getglobal(varParts[1]);					
	if (not aVar) then
		PratFu:TextMessage(varParts[1].." not found !",1);
		return;
	end
	for i=2,(#varParts)-1 do
		aVar = aVar[varParts[i]];
		--DEFAULT_CHAT_FRAME:AddMessage("avar "..i);
		if (not aVar) then
			PratFu:TextMessage(varParts[i].." not found !",1);
			return;
		end		
	end
	
	if #varParts == 1 then
		PratFu.db.profile.rootVariable = variableName;
		self:BuildNode(nil, 0, varParts[1],0);
	else
		if (not aVar[varParts[#varParts]]) then
			PratFu:TextMessage(varParts[#varParts].." not found !",1);
			return;			
		end
		PratFu.db.profile.rootVariable = variableName;
		self:BuildNode(aVar, 0, varParts[#varParts],0);
	end
	
	self.db.profile.newTreeBuild = 1;
	--self:CheckTooltipAttachment(1)	
	self:Update();	
end

function PratFu:ToggleAllNodes(depth,expand)	
	if (depth) then
		--DEFAULT_CHAT_FRAME:AddMessage("ToggleAll "..depth.." - "..expand);
		for _,i in ipairs(self.db.profile.varTree) do			
			if (i.expanded) and (i.depth == depth) then -- is a table
				i.expanded = expand;
			end
		end		
	end
end

-- Build a node of the variable's tree
function PratFu:BuildNode(parent, parentIndex, nodeName, depth, expand)

	-- Get the current node
	local node = self:GetNode(nodeName, parent)
		
	-- Get the type of the node
	local nodeType = type(node);
	
	--DEFAULT_CHAT_FRAME:AddMessage("type "..nodeType);
	
	-- Check the type of the node
	if (nodeType == "number" or nodeType == "string" or nodeType == "boolean") then
		--DEFAULT_CHAT_FRAME:AddMessage("Insert Bool "..nodeName.." "..nodeType);		
		table.insert(self.db.profile.varTree, {name = nodeName, parentIndex = parentIndex,depth = depth, value = node});
	elseif (nodeType == "table") then
	
		if string.sub(nodeName, -3) == "IDX" then
			return
		end
		local orderTable = self:GetNode(nodeName.."IDX", parent)
    
        -- Expand the tree for the current chat frame
        if nodeName == PratFu.chatFrameSel and depth == 1 then
		        expand = 1
		end	
		table.insert(self.db.profile.varTree, {name = nodeName, parentIndex = parentIndex,depth = depth, expanded = expand or 0});
		
		local currentIndex = #self.db.profile.varTree;
	--	DEFAULT_CHAT_FRAME:AddMessage("Insert "..nodeName.." "..currentIndex);		

		if orderTable then
			local keys = util:merge_keys(orderTable, node)	
			for _,k in ipairs(keys) do
				local childNode = node[k] and k
				if childNode ~= nil then 
	--				DEFAULT_CHAT_FRAME:AddMessage("new call 1"..childNode);		
					self:BuildNode(node, currentIndex, childNode, depth+1, expand);
				end
			end
		else		
			for childNode,_ in pairs(node) do
				if childNode ~= nil and childNode ~= "super"  and childNode ~= "hooks" then
		--		DEFAULT_CHAT_FRAME:AddMessage("new call 2"..childNode);		
					self:BuildNode(node, currentIndex, childNode, depth+1, expand);
				end
			end
		end
		
		
	end
end

function PratFu:GetNode(nodeName, parent)
    if type(nodeName) ==  "table" or type(nodeName) ==  "function" then return end
	local node
	if (parent) then
		node = parent[nodeName];
--		DEFAULT_CHAT_FRAME:AddMessage("const subnode "..(node and nodeName or "nil"));
	else
		node = getglobal(nodeName);
--		DEFAULT_CHAT_FRAME:AddMessage("global get "..nodeName);
	end;
	
	return node
end
